#!/usr/bin/env python3
#
# Script for basic semester management tasks.  See README.org
# Ben Wood, 2018

# Depends on Python 3 for umask behavior.
import sys
assert(sys.version_info >= (3,3))

import argparse
import os
import shutil
import sys

UMASK = 0o0022
ADMIN_DIR = os.path.dirname(os.path.dirname(__file__))
COMMAND = os.path.basename(__file__)

COURSE = os.path.basename(os.getenv("HOME"))
HTACCESS_TEMPLATE_PATH = os.path.join(ADMIN_DIR, "htaccess.template")
NOEDIT_MSG = """
# DO NOT EDIT THIS FILE.
# It is automatically generated by the command {command}
# from the template {template}.
#
# Semester specific rules belong in a separate .htaccess file
# in the semester web directory.
""".format(command=COMMAND, template=HTACCESS_TEMPLATE_PATH)

ARCHIVE_DIR = os.path.expanduser("~/archive")
ARCHIVE_ENV_NAME = "env"
ARCHIVE_WWW_NAME = "www"
ARCHIVE_SUBDIRS = [
    ARCHIVE_ENV_NAME,
    ARCHIVE_WWW_NAME
]

WWW_DIR = os.path.expanduser("~/public_html")
WWW_HTACCESS_PATH = os.path.join(WWW_DIR, ".htaccess")

LIVE_LINK = os.path.expanduser("~/live")

PREP_MSG_TEMPLATE = """
Created {path}
Linked  {www_link} -> {www_path}
URL is  https://cs.wellesley.edu/~{course}/{sid}/
"""

def prep(sid, copy_sid=None):
    oldmask = os.umask(UMASK)
    try:
        path = os.path.join(ARCHIVE_DIR, sid)
        www_path = os.path.join(ARCHIVE_DIR, sid, ARCHIVE_WWW_NAME)
        www_link = os.path.join(WWW_DIR, sid)
        ok = True
        for p in [path, www_link]:
            if os.path.exists(p):
                print("error: {p} exists".format(p=p))
                ok = False
        if not ok:
            exit(3)
        if copy_sid:
            source_path = os.path.join(ARCHIVE_DIR, copy_sid)
            if not os.path.exists(source_path):
                print("error: {source} does not exist".format(source=source_path))
                exit(4)
            shutil.copytree(source_path, path)
        for d in ARCHIVE_SUBDIRS:
            os.makedirs(os.path.join(ARCHIVE_DIR, sid, d), exist_ok=True)

        os.symlink(www_path, www_link)
        print(PREP_MSG_TEMPLATE.strip().format(sid=sid,
                                               path=path,
                                               www_link=www_link,
                                               www_path=www_path,
                                               course=COURSE))
    finally:
        os.umask(oldmask)
    return sid

LIVE_MSG_TEMPLATE = """
Linked     {link} -> {path}
Redirected https://cs.wellesley.edu/~{course}/
        -> https://cs.wellesley.edu/~{course}/{sid}/
"""

def link(sid):
    oldmask = os.umask(UMASK)
    try:
        path = os.path.join(ARCHIVE_DIR, sid)
        if not os.path.exists(path):
            print("error: {source} does not exist".format(source=path))
            exit(4)
        if os.path.exists(LIVE_LINK):
            os.remove(LIVE_LINK)
        os.symlink(path, LIVE_LINK)
        with open(HTACCESS_TEMPLATE_PATH) as template_file:
            template = template_file.read()
            tmp_path = WWW_HTACCESS_PATH + ".tmp"
            with open(tmp_path, 'w') as htaccess:
                htaccess.write(NOEDIT_MSG)
                htaccess.write("\n\n")
                htaccess.write(template.format(course=COURSE, semester=sid))
        os.rename(tmp_path, WWW_HTACCESS_PATH)
        print(LIVE_MSG_TEMPLATE.strip().format(sid=sid,
                                               link=LIVE_LINK,
                                               path=path,
                                               course=COURSE))
    finally:
        os.umask(oldmask)
    return sid
    
    
if __name__ == "__main__":
    parser = argparse.ArgumentParser(prog=COMMAND)

    subparsers = parser.add_subparsers(prog=COMMAND, title='tasks',
                                       dest='task')
    
    prep_parser = subparsers.add_parser("new", help="Create a new semester from scratch.")
    prep_parser.add_argument("sid", help="ID (e.g., f18) of new semester to create")

    copy_parser = subparsers.add_parser("copy", help="Create a new semester by copying an existing semester.")
    copy_parser.add_argument("oldsid", help="ID (e.g., f18) of existing semester to copy")
    copy_parser.add_argument("newsid", help="ID (e.g., f18) of new semester to create")

    link_parser = subparsers.add_parser("link", help="Link the live semester.")
    link_parser.add_argument("sid", help="ID (e.g., f18) of semester to link live")

    opts = parser.parse_args()

    if opts.task == 'new':
        prep(opts.sid)
    elif opts.task == 'copy':
        prep(opts.newsid, copy_sid=opts.oldsid)
    elif opts.task == 'link':
        link(opts.sid)
    else:
        parser.parse_args(['-h'])
        exit(2)


